---- Button.e

with trace
global sequence act_btns
act_btns = {}

global atom SHADE_L, SHADE_D
SHADE_L = BRIGHT_WHITE -- These colors outline the buttons
SHADE_D = WHITE
global function draw_button(sequence xy, integer width, integer height, sequence string, integer btn_color, integer txt_color)
  atom x1,y1
  integer ID
  
  ID = length(act_btns) + 1

  x1 = (xy[1] + width/2)-(length(string))*4
  x1 = floor(x1)
  if x1 < xy[1] then return -1 end if
  y1 = (xy[2] + height/2)-8
  y1 =floor(y1)
 

  for i = xy[1] to xy[1]+width do
    draw_line(btn_color,{{i, xy[2]},{i,xy[2]+height}})
  end for
  draw_line(SHADE_L, {{xy[1],xy[2]},{xy[1], xy[2]+height}})
  draw_line(SHADE_L, {{xy[1]+1, xy[2]+1},{xy[1]+width,xy[2]+1}})
  draw_line(SHADE_L, {{xy[1]+1,xy[2]+1},{xy[1]+1, xy[2]+height}})
  draw_line(SHADE_L, {{xy[1]+1, xy[2]},{xy[1]+width,xy[2]}})
  draw_line(SHADE_L, {{xy[1]+2, xy[2]+3},{xy[1]+2,xy[2]+1},{xy[1]+4,xy[2]+1}})

  draw_line(SHADE_D, {{xy[1]+1,xy[2]+height-1},{xy[1] + width,xy[2]+height-1}})
  draw_line(SHADE_D, {{xy[1]+1,xy[2]+height},{xy[1] + width,xy[2]+height}})
  draw_line(SHADE_D, {{xy[1]+width,xy[2]},{xy[1] + width,xy[2]+height}})
  draw_line(SHADE_D, {{xy[1]+width-1,xy[2]},{xy[1] + width-1,xy[2]+height}})

  putsxy({x1,y1},string,txt_color, btn_color,1)
  for i = 1 to length(act_btns) do
    if equal(act_btns[i],-1) then
      act_btns[i] = {ID,xy,width,height,string,btn_color,txt_color}
      return i
    end if
  end for
  act_btns = append(act_btns, {ID,xy,width,height,string,btn_color,txt_color}) 
  return length(act_btns)

end function

global function check_buttons(object Mouse_Event)
-- when there is a mouse event, it checks to see if a button has been pressed
  if sequence(Mouse_Event) then  -- if a mouse event has occured
    if Mouse_Event[1] = LEFT_DOWN then
      for i = 1 to length(act_btns) do
        if equal(act_btns[i],-1) then
        else
          if act_btns[i][2][1] + act_btns[i][3] >=Mouse_Event[2] and Mouse_Event[2] >= act_btns[i][2][1] then
            if act_btns[i][2][2] + act_btns[i][4] >=Mouse_Event[3] and Mouse_Event[3] >= act_btns[i][2][2] then       
              return i
            end if
          end if
        end if
      end for
    else return -1
    end if
  else return -1
  end if 
  return -1 
end function

global procedure delete_button(integer btn, integer bkgd_clr)
  sequence xy
  integer height, width
  
  xy = act_btns[btn][2]
  width = act_btns[btn][3]
  height = act_btns[btn][4]

  for i = 0 to width do
    draw_line(bkgd_clr, {{xy[1]+i, xy[2]},{xy[1]+i,xy[2] + height}})
  end for
  act_btns[btn] = -1
   
end procedure

